local AB = GetSpellInfo(42897) -- Arcane Blast
local ABCount = nil

local GetFramesRegisteredForEvent = GetFramesRegisteredForEvent

local function helper(n, frame, ...)
   if n > 0 then
      frame:GetScript('OnEvent')(frame, 'UNIT_COMBO_POINTS', 'player')
      helper(n-1, ...)
   end
end

local select = select
local function map(...)
   helper(select('#', ...), ...)
end

local frame = CreateFrame('frame')
frame:RegisterEvent('PLAYER_LOGIN')
frame:SetScript('OnEvent', function(self, event, unit, ...)
	if event == 'UNIT_AURA' and unit == 'player' then
      local _,_,_,count = UnitDebuff('player', AB)
      if count ~= ABCount then
         ABCount = count
         map(GetFramesRegisteredForEvent('UNIT_COMBO_POINTS'))   -- fake fire UNIT_COMBO_POINTS
      end
	elseif event == 'PLAYER_LOGIN' then
      self:UnregisterEvent('PLAYER_LOGIN')
      local _,class = UnitClass('player')
      if class == 'MAGE' then
         local UnitExists = UnitExists
         local oldGetComboPoints = GetComboPoints
         GetComboPoints = function(...)
            return UnitExists('target') and ABCount or oldGetComboPoints(...)
         end
         frame:RegisterEvent('UNIT_AURA')
      end
	end
end)
